Compare commits

...

4 Commits

7 changed files with 250 additions and 3 deletions

33
Dockerfile Normal file
View File

@ -0,0 +1,33 @@
FROM reg.cadoles.com/proxy_cache/library/alpine:latest
# Packages needed
RUN apk update
RUN apk add alpine-sdk build-base mtools dosfstools grub-efi apk-tools alpine-conf busybox fakeroot syslinux xorriso squashfs-tools sudo
# User setup
RUN adduser build -G abuild -D
RUN chown build:abuild /home/build -R
# Grant unrestricted sudo to abuild group
RUN echo "%abuild ALL=(ALL) NOPASSWD: ALL" > /etc/sudoers.d/abuild
USER build
WORKDIR /home/build
RUN abuild-keygen -n -i -a
RUN git clone --depth=1 https://gitlab.alpinelinux.org/alpine/aports.git
USER root
RUN apk update
COPY ./scripts/create-iso.sh /usr/bin/create-iso.sh
RUN chmod +x /usr/bin/create-iso.sh
COPY ./scripts/aports/* /home/build/aports/scripts/
RUN chmod +x /home/build/aports/scripts/*.sh
USER build
WORKDIR /home/build
CMD [ "/usr/bin/create-iso.sh", "ckubeos", "3.16"]

View File

@ -1,5 +1,35 @@
# os
Cadoles Kubernetes Operating System
a.k.a. CadolesKube/os
Cadoles Kubernetes Operating System
a.k.a. CadolesKube/os
##Creating a build server for AlpineLinux
On Alpine server run : at-begining.sh to install necessary tools.
##Change to the build user :
```su - build```
##Create signing key:
```abuild-keygen -i -a (-i installs them in /etc/apk/keys)```
##Quick check :
```ls -lah /etc/apk/keys/build-xxxxxxxx.rsa.pub```
##Clone the git repository :
```git clone --depth=1 https://gitlab.alpinelinux.org/alpine/aports.git```
##Update :
```sudo apk updat```
Copy script 'create-iso.sh' in '/home/build'
You must enter a profile name to launch the creation of the iso. The iso is built with Edge sources to have Kubernetes tools.
For example ./create-iso.sh myKube.
The iso is generated in the ~/iso folder.

24
at-begining.sh Normal file
View File

@ -0,0 +1,24 @@
#!/bin/sh
# Install base builder
if test $(id -u) -ne 0; then
echo "Be root is better for this action !!"
exit 1
fi
if test ! -f /etc/apk/world; then
echo "Maybe, You should try on an Alpine !"
exit 1
fi
# Packages needed
apk add alpine-sdk build-base apk-tools alpine-conf busybox fakeroot syslinux xorriso squashfs-tools sudo
# User setup
adduser build -G abuild
# Grant unrestricted sudo to abuild group
echo "%abuild ALL=(ALL) ALL" > /etc/sudoers.d/abuild
# Also, update apk
apk update

0
config/apk/world Normal file
View File

View File

@ -0,0 +1,112 @@
#!/bin/sh -e
HOSTNAME="$1"
if [ -z "$HOSTNAME" ]; then
echo "usage: $0 hostname"
exit 1
fi
cleanup() {
rm -rf "$tmp"
}
makefile() {
OWNER="$1"
PERMS="$2"
FILENAME="$3"
cat > "$FILENAME"
chown "$OWNER" "$FILENAME"
chmod "$PERMS" "$FILENAME"
}
rc_add() {
mkdir -p "$tmp"/etc/runlevels/"$2"
ln -sf /etc/init.d/"$1" "$tmp"/etc/runlevels/"$2"/"$1"
}
tmp="$(mktemp -d)"
trap cleanup EXIT
mkdir -p "$tmp"/etc
makefile root:root 0644 "$tmp"/etc/hostname <<EOF
$HOSTNAME
EOF
mkdir -p "$tmp"/etc/network
makefile root:root 0644 "$tmp"/etc/network/interfaces <<EOF
auto lo
iface lo inet loopback
auto eth0
iface eth0 inet dhcp
EOF
mkdir -p "$tmp/root/.ssh"
mkdir -p "$tmp/etc/apk"
echo '/media/cdrom' >> "$tmp/etc/apk/repositories"
echo "http://dl-cdn.alpinelinux.org/alpine/v3.16/main" >> "$tmp/etc/apk/repositories"
echo "http://dl-cdn.alpinelinux.org/alpine/v3.16/community" >> "$tmp/etc/apk/repositories"
echo "http://dl-cdn.alpinelinux.org/alpine/edge/testing" >> "$tmp/etc/apk/repositories"
echo "http://dl-cdn.alpinelinux.org/alpine/edge/community" >> "$tmp/etc/apk/repositories"
mkdir -p "$tmp"/etc/apk
makefile root:root 0644 "$tmp"/etc/apk/world <<EOF
alpine-base
util-linux
xfsprogs
vim
dfc
cni-plugin-flannel
cni-plugins
flannel
flannel-contrib-cni
kubelet
kubeadm
kubectl
uuidgen
docker
mtools
dosfstools
grub-efi
EOF
mkdir -p "$tmp"/etc/local.d
# =------------------------------------------------------------=
# Hello preseed script, my new friend.
#
# Note the single quotes around the EOF, to avoid evaluation
# at the time genapkovl runs.
# =------------------------------------------------------------=
makefile root:root 0755 "$tmp"/etc/local.d/preseed.start <<'EOF'
#!/bin/sh
# Fail fast, if we make it onto a live system.
test "$(hostname)" = "" || exit 111
# Here would be the preseed script in earnest. One that sets
# the hostname to something else than `preseed`, or at least
# makes sure the /etc/local.d/preseed.start isn't carried over.
# Lest you're a glutton for punishment.
echo "preseeded at $(date)" >> /root/preseeded.txt
EOF
rc_add devfs sysinit
rc_add dmesg sysinit
rc_add mdev sysinit
rc_add hwdrivers sysinit
rc_add modloop sysinit
rc_add hwclock boot
rc_add modules boot
rc_add sysctl boot
rc_add hostname boot
rc_add bootmisc boot
rc_add syslog boot
# we want our preseed to run & have network while at it
rc_add networking boot
rc_add local boot
rc_add mount-ro shutdown
rc_add killprocs shutdown
rc_add savecache shutdown
tar -c -C "$tmp" etc | gzip -9n > $HOSTNAME.apkovl.tar.gz

View File

@ -0,0 +1,17 @@
profile_ckubeos() {
profile_standard
kernel_cmdline="unionfs_size=512M console=tty0 console=ttyS0,115200"
syslinux_serial="0 115200"
apks="$apks mtools parted rsync mtools dosfstools grub-efi vim util-linux curl coreutils strace dhcp dhcpcd kubeadm lvm2 dfc cni-plugin-flannel cni-plugins
flannel flannel-contrib-cni kubelet kubeadm kubectl uuidgen docker"
local _k _a
for _k in $kernel_flavors; do
apks="$apks linux-$_k"
for _a in $kernel_addons; do
apks="$apks $_a-$_k"
done
done
apks="$apks linux-firmware"
hostname="ckubeos"
apkovl="genapkovl-ckubeos.sh"
}

31
scripts/create-iso.sh Normal file
View File

@ -0,0 +1,31 @@
#!/bin/sh
#if [[ -z $1 || -z $2 ]]; then
if [[ -z $1 ]]; then
echo -e "ERREUR : paramétre(s) manquant(s) "
echo -e "Passer en paramétre : "
echo -e "1. Nom du profil (ex : ckubeos)"
# echo -e "2. Version de l'Alpine (forcé à edge pour le moment)"
echo ""
exit 1
else
PROFILENAME=$1
ALPINE_VERSION=$2
# Create output dir
if test ! -d ~/iso; then
echo "Creating output dir"
mkdir -p ~/iso
fi
echo "ISO generation"
cd ~/aports/scripts/
sh mkimage.sh --tag $ALPINE_VERSION \
--outdir /home/build/iso \
--arch x86_64 \
--repository http://dl-cdn.alpinelinux.org/alpine/v$ALPINE_VERSION/main \
--repository http://dl-cdn.alpinelinux.org/alpine/v$ALPINE_VERSION/community \
--repository http://dl-cdn.alpinelinux.org/alpine/edge/testing \
--repository http://dl-cdn.alpinelinux.org/alpine/edge/community \
--profile $PROFILENAME
fi